diff -ur sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2019-02-15 09:37:36.768000000 +1000
+++ source/scripts/jmgUtility.cpp	2019-06-22 07:43:44.244400000 +1000
@@ -10875,6 +11109,1012 @@
 		Console_Input(errorMsg);
 	}
 }
+void JMG_Utility_Custom_Send_Cycled_Customs::Created(GameObject *obj)
+{
+	cycle = 0;
+	recieveMessage = Get_Int_Parameter("Custom");
+	id = Get_Int_Parameter("ID");
+	for (int x = 0;x < 10;x++)
+	{
+		char parameterName[128];
+		sprintf(parameterName,"SendCustom%0d",x);
+		custom[x] = Get_Int_Parameter(parameterName);
+		sprintf(parameterName,"Param%0d",x);
+		Param[x] = Get_Int_Parameter(parameterName);
+		sprintf(parameterName,"Delay%0d",x);
+		delay[x] = Get_Float_Parameter(parameterName);
+	}
+	randomDelay = Get_Float_Parameter("RandomDelay");
+	randomChance = Get_Float_Parameter("RandomChance");
+}
+void JMG_Utility_Custom_Send_Cycled_Customs::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == recieveMessage)
+	{
+		if (randomChance && randomChance < Commands->Get_Random(0.0f,1.0f))
+			return;
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+ 		Commands->Send_Custom_Event(obj,object,custom[cycle],Param[cycle] == -1 ? param : Param[cycle],delay[cycle]+(randomDelay > 0 ? Commands->Get_Random(0.0f,randomDelay) : 0.0f));
+		cycle++;
+		if (!custom[cycle])
+			cycle = 0;
+	}
+}
+void JMG_Utility_Killed_Send_Custom_From_Killer::Killed(GameObject *obj,GameObject *killer)
+{
+	if (!Commands->Is_A_Star(killer))
+		return;
+	int id = Get_Int_Parameter("ID");
+	GameObject *object = id ? (id == -1 ? killer : Commands->Find_Object(id)) : obj;
+	Commands->Send_Custom_Event(killer,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+	Destroy_Script();
+}
+void JMG_Utility_Emulate_Sound_Heard_On_FDS::Created(GameObject *obj)
+{
+	if (!The_Game()->Is_Dedicated())
+	{
+		Destroy_Script();
+		return;
+	}
+	if (!obj->As_SoldierGameObj())
+	{
+		Console_Input("msg JMG_Utility_Emulate_Sound_Heard_On_FDS::ERROR Only attach to soldiers!");
+		Destroy_Script();
+		return;
+	}
+	crouchSoundId = Get_Int_Parameter("DefaultCrouchMoveSoundID");
+	walkSoundId = Get_Int_Parameter("DefaultWalkMoveSoundID");
+	runSoundId = Get_Int_Parameter("DefaultRunMoveSoundID");
+	updateRate = Get_Float_Parameter("UpdateRate");
+	currentWeapon = WeaponNode(obj);
+	vehicleWeapon = WeaponNode();
+	Commands->Start_Timer(obj,this,updateRate,1);
+}
+void JMG_Utility_Emulate_Sound_Heard_On_FDS::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1 && Commands->Get_Health(obj))
+	{
+		CombatSound sound;
+		sound.Creator = obj;
+		sound.sound = 0;
+		sound.Position = Commands->Get_Position(obj);
+		WeaponNode::FireWeaponReturn weaponFire = FiredWeapon(obj);
+		if (weaponFire == WeaponNode::FireWeaponReturn::INFANTRY_FIRE)
+		{
+			const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(currentWeapon.weaponName,true);
+			if (ammo)
+				sound.sound = ammo->FireSoundDefID;
+		}
+		else if (weaponFire == WeaponNode::FireWeaponReturn::VEHICLE_FIRE)
+		{
+			const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(vehicleWeapon.weaponName,true);
+			if (ammo)
+				sound.sound = ammo->FireSoundDefID;
+		}
+		else
+		{
+			Vector3 tempSpeed;
+			obj->As_SoldierGameObj()->Get_Velocity(tempSpeed);
+			if (tempSpeed.Length2() > 0)
+			{
+				SoldierGameObj *solderGameObj = obj->As_SoldierGameObj();
+				if (solderGameObj->Is_Crouched())
+					sound.sound = crouchSoundId;
+				else if (solderGameObj->Is_Slow())
+					sound.sound = walkSoundId;
+				else
+					sound.sound = runSoundId;
+			}
+		}
+		if (sound.sound)
+		{
+			AudibleSoundDefinitionClass *soundDef = (AudibleSoundDefinitionClass *)DefinitionMgrClass::Find_Definition(sound.sound,true);
+			if (soundDef)
+			{
+				float soundRangeSquared = soundDef->Get_Logical_DropOff_Radius()*soundDef->Get_Logical_DropOff_Radius();
+				sound.sound = soundDef->Get_Logical_Type();
+				for (SLNode<SmartGameObj> *node = GameObjManager::SmartGameObjList.Head();node;node = node->Next())
+				{
+					SmartGameObj* object = node->Data();
+					if (object == obj)
+						continue;
+					if (JmgUtility::SimpleDistance(Commands->Get_Position(object),sound.Position) > soundRangeSquared)
+						continue;
+					const SimpleDynVecClass<GameObjObserverClass *>& observer_list = object->Get_Observers();
+					for(int index = 0;index < observer_list.Count();index++)
+						observer_list[index]->Sound_Heard(object,sound);
+				}
+			}
+		}
+		Commands->Start_Timer(obj,this,updateRate,1);
+	}
+}
+JMG_Utility_Emulate_Sound_Heard_On_FDS::WeaponNode::FireWeaponReturn JMG_Utility_Emulate_Sound_Heard_On_FDS::FiredWeapon(GameObject *obj)
+{
+	if (_stricmp(currentWeapon.weaponName,Get_Current_Weapon(obj)))
+	{
+		currentWeapon = WeaponNode(obj);
+		return WeaponNode::FireWeaponReturn::NONE;
+	}
+	GameObject *vehicle = Get_Vehicle(obj);
+	if (vehicle)
+	{
+		int currentBullets = vehicleWeapon.GetWeaponBullets(vehicle);
+		if (currentBullets < vehicleWeapon.totalBullets)
+		{
+			vehicleWeapon.totalBullets = currentBullets;
+			return WeaponNode::FireWeaponReturn::VEHICLE_FIRE;
+		}
+		return WeaponNode::FireWeaponReturn::NONE;
+	}
+	int currentBullets = currentWeapon.GetWeaponBullets(obj);
+	if (currentBullets < currentWeapon.totalBullets)
+	{
+		currentWeapon.totalBullets = currentBullets;
+		return WeaponNode::FireWeaponReturn::INFANTRY_FIRE;
+	}
+	return WeaponNode::FireWeaponReturn::NONE;
+}
+void JMG_Utility_Send_Custom_When_Team_Dominates_Zone::Created(GameObject *obj)
+{
+	team = Get_Int_Parameter("Team");
+	teamHoldingZone = sBool::sNULL;
+	enabled = Get_Int_Parameter("StartsEnabled") != 0;
+	enableCustom = Get_Int_Parameter("EnableCustom");
+	id = Get_Int_Parameter("ID");
+	captureCustom = Get_Int_Parameter("CaptureCustom");
+	captureParam = Get_Int_Parameter("CaptureParam");
+	lostCustom = Get_Int_Parameter("LostCustom");
+	lostParam = Get_Int_Parameter("LostParam");
+	delay = Get_Float_Parameter("CaptureDelay");
+	rate = Get_Float_Parameter("Rate");
+	sendCustomEveryTick = Get_Int_Parameter("SendCustomEveryTick")!=0;
+	Commands->Start_Timer(obj,this,rate,1);
+}
+void JMG_Utility_Send_Custom_When_Team_Dominates_Zone::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1)
+	{
+		if (enabled)
+		{
+			int teamCount = 0,enemyCount = 0;
+			for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
+			{
+				SmartGameObj* o = current->Data();
+				if (o != obj && Commands->Get_Health(o) && IsInsideZone(obj,o))
+				{
+					int myTeam = Commands->Get_Player_Type(o);
+					if (myTeam == -2 || Is_Script_Attached(o,"JMG_Utility_Send_Custom_When_Team_Dominates_Zone_Ignore"))
+						continue;
+					if (myTeam == team)
+						teamCount++;
+					else
+						enemyCount++;
+				}
+			}
+			if (teamCount > enemyCount)
+			{
+				if (teamHoldingZone != sBool::sTRUE || sendCustomEveryTick)
+				{
+					GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 					Commands->Send_Custom_Event(obj,object,captureCustom,captureParam == -1 ? teamCount : captureParam,delay);
+					teamHoldingZone = sBool::sTRUE;
+				}
+			}
+			else if (teamHoldingZone != sBool::sFALSE || sendCustomEveryTick)
+			{
+				GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 				Commands->Send_Custom_Event(obj,object,lostCustom,lostParam == -1 ? teamCount : lostParam,delay);
+				teamHoldingZone = sBool::sFALSE;
+			}
+		}
+		Commands->Start_Timer(obj,this,rate,1);
+	}
+}
+void JMG_Utility_Send_Custom_When_Team_Dominates_Zone::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == enableCustom)
+	{
+		if (enabled != (param!=0))
+			teamHoldingZone = sBool::sNULL;
+		enabled = param!=0;
+	}
+}
+void JMG_Utility_Send_Custom_When_Team_Zone::Created(GameObject *obj)
+{
+	team = Get_Int_Parameter("Team");
+	teamInZone = sBool::sNULL;
+	enabled = Get_Int_Parameter("StartsEnabled") != 0;
+	enableCustom = Get_Int_Parameter("EnableCustom");
+	id = Get_Int_Parameter("ID");
+	inCustom = Get_Int_Parameter("InCustom");
+	inParam = Get_Int_Parameter("InParam");
+	outCustom = Get_Int_Parameter("OutCustom");
+	outParam = Get_Int_Parameter("OutParam");
+	delay = Get_Float_Parameter("Delay");
+	rate = Get_Float_Parameter("Rate");
+	sendCustomEveryTick = Get_Int_Parameter("SendCustomEveryTick") != 0;
+	Commands->Start_Timer(obj,this,rate,1);
+}
+void JMG_Utility_Send_Custom_When_Team_Zone::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1)
+	{
+		if (enabled)
+		{
+			int teamCount = 0;
+			for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
+			{
+				SmartGameObj* o = current->Data();
+				if (o != obj && Commands->Get_Health(o) && IsInsideZone(obj,o))
+				{
+					int myTeam = Commands->Get_Player_Type(o);
+					if (myTeam == -2 || Is_Script_Attached(o,"JMG_Utility_Send_Custom_When_Team_Zone_Ignore"))
+						continue;
+					if (myTeam == team)
+						teamCount++;
+				}
+			}
+			if (teamCount > 0)
+			{
+				if (teamInZone != sBool::sTRUE || sendCustomEveryTick)
+				{
+					GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 					Commands->Send_Custom_Event(obj,object,inCustom,inParam,delay);
+					teamInZone = sBool::sTRUE;
+				}
+			}
+			else
+			{
+				if (teamInZone != sBool::sFALSE || sendCustomEveryTick)
+				{
+					GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 					Commands->Send_Custom_Event(obj,object,outCustom,outParam,delay);
+					teamInZone = sBool::sFALSE;
+				}
+			}
+		}
+		Commands->Start_Timer(obj,this,rate,1);
+	}
+}
+void JMG_Utility_Send_Custom_When_Team_Zone::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == enableCustom)
+	{
+		if (enabled != (param!=0))
+			teamInZone = sBool::sNULL;
+		enabled = param!=0;
+	}
+}
+void JMG_Utility_HUD_Count_Down_Visible_Countdown::Created(GameObject *obj)
+{
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_HUD_Count_Down_Visible_Countdown::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		JMG_Utility_HUD_Count_Down::AddVisualCountdownNode(Commands->Get_ID(obj),Get_Int_Parameter("CharPos"),Get_Parameter("BaseModelName"));
+	}
+}
+void JMG_Utility_Custom_Send_Custom_On_Secondary_Count::Created(GameObject *obj)
+{
+	triggerCustom = Get_Int_Parameter("TriggerCustom");
+	countCustom = Get_Int_Parameter("CountCustom");
+	count = Get_Int_Parameter("MatchCount");
+	id = Get_Int_Parameter("ID");
+	sendCustom = Get_Int_Parameter("SendCustom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	resetCustom = Get_Int_Parameter("ResetCountCustom");
+	onceMatchedContinue = Get_Int_Parameter("OnceMatchedContinue") != 0;
+}
+void JMG_Utility_Custom_Send_Custom_On_Secondary_Count::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == resetCustom)
+	{
+		count = Get_Int_Parameter("Count");
+	}
+	if (message == countCustom)
+	{
+		if ((!onceMatchedContinue && count >= 0) || (onceMatchedContinue && count))
+			count--;
+	}
+	if (message == triggerCustom && !count)
+	{
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+		if (object)
+		{
+			Commands->Send_Custom_Event(obj,object,sendCustom,Param == -1 ? param : Param,delay);
+		}
+	}
+}
+void JMG_Utility_Send_Custom_When_Not_Team_Zone::Created(GameObject *obj)
+{
+	team = Get_Int_Parameter("Team");
+	teamInZone = sBool::sNULL;
+	enabled = Get_Int_Parameter("StartsEnabled") != 0;
+	enableCustom = Get_Int_Parameter("EnableCustom");
+	id = Get_Int_Parameter("ID");
+	inCustom = Get_Int_Parameter("InCustom");
+	inParam = Get_Int_Parameter("InParam");
+	outCustom = Get_Int_Parameter("OutCustom");
+	outParam = Get_Int_Parameter("OutParam");
+	delay = Get_Float_Parameter("Delay");
+	rate = Get_Float_Parameter("Rate");
+	sendCustomEveryTick = Get_Int_Parameter("SendCustomEveryTick") != 0;
+	Commands->Start_Timer(obj,this,rate,1);
+}
+void JMG_Utility_Send_Custom_When_Not_Team_Zone::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1)
+	{
+		if (enabled)
+		{
+			int teamCount = 0;
+			for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
+			{
+				SmartGameObj* o = current->Data();
+				if (o != obj && Commands->Get_Health(o) && IsInsideZone(obj,o))
+				{
+					int myTeam = Commands->Get_Player_Type(o);
+					if (myTeam == -2 || Is_Script_Attached(o,"JMG_Utility_Send_Custom_When_Not_Team_Zone_Ignore"))
+						continue;
+					if (myTeam != team)
+						teamCount++;
+				}
+			}
+			if (teamCount > 0)
+			{
+				if (teamInZone != sBool::sTRUE || sendCustomEveryTick)
+				{
+					GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 					Commands->Send_Custom_Event(obj,object,inCustom,inParam,delay);
+					teamInZone = sBool::sTRUE;
+				}
+			}
+			else
+			{
+				if (teamInZone != sBool::sFALSE || sendCustomEveryTick)
+				{
+					GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 					Commands->Send_Custom_Event(obj,object,outCustom,outParam,delay);
+					teamInZone = sBool::sFALSE;
+				}
+			}
+		}
+		Commands->Start_Timer(obj,this,rate,1);
+	}
+}
+void JMG_Utility_Send_Custom_When_Not_Team_Zone::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == enableCustom)
+	{
+		if (enabled != (param!=0))
+			teamInZone = sBool::sNULL;
+		enabled = param!=0;
+	}
+}
+void JMG_Utility_Send_Custom_When_Team_Dominates_Zone_Ignore::Created(GameObject *obj)
+{
+}
+void JMG_Utility_Send_Custom_When_Team_Zone_Ignore::Created(GameObject *obj)
+{
+}
+void JMG_Utility_Send_Custom_When_Not_Team_Zone_Ignore::Created(GameObject *obj)
+{
+}
+void JMG_Utility_Send_Custom_On_Armor::Created(GameObject *obj)
+{
+	id = Get_Int_Parameter("ID");
+	armorCustom = Get_Int_Parameter("ArmorCustom");
+	armorParam = Get_Int_Parameter("ArmorParam");
+	noArmorCustom = Get_Int_Parameter("NoArmorCustom");
+	noArmorParam = Get_Int_Parameter("NoArmorParam");
+	delay = Get_Float_Parameter("Delay");
+	hurt = Commands->Get_Shield_Strength(obj) < Commands->Get_Max_Shield_Strength(obj);
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Send_Custom_On_Armor::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (hurt && Commands->Get_Shield_Strength(obj) >= Commands->Get_Max_Shield_Strength(obj))
+		{
+			hurt = false;
+			GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 			Commands->Send_Custom_Event(obj,object,armorCustom,armorParam,delay);
+		}
+		if (!hurt && !Commands->Get_Shield_Strength(obj))
+		{
+			hurt = true;
+			GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 			Commands->Send_Custom_Event(obj,object,noArmorCustom,noArmorParam,delay);
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Base_Defense_Simple::Created(GameObject *obj)
+{
+	resetTime = 0;
+	Commands->Enable_Enemy_Seen(obj,true);
+	enemyId = 0;
+	minDist = Get_Float_Parameter("MinAttackDistance")*Get_Float_Parameter("MinAttackDistance");
+	maxDistance = Get_Float_Parameter("MaxAttackDistance");
+	carTankBike = Get_Vector3_Parameter("AttackPriority[Car|Tank|Bike]");
+	flyingTurretBoat = Get_Vector3_Parameter("AttackPriority[Flying|Turret|Boat]");
+	submarineInfantryUnused = Get_Vector3_Parameter("AttackPriority[Submarine|Infantry|Unused]");
+	userSetResetTime = (int)(Get_Float_Parameter("ResetTime")*10);
+	maxDist = maxDistance*maxDistance;
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Base_Defense_Simple::Enemy_Seen(GameObject *obj,GameObject *seen)
+{
+	GameObject *vehicle = Get_Vehicle(seen);
+	if (vehicle)
+		seen = vehicle;
+	float seenPriority = GetPriority(seen);
+	if (!seenPriority)
+		return;
+	if (!Commands->Get_Health(seen))
+		return;
+	float distance = JmgUtility::SimpleDistance(Commands->Get_Position(obj),Commands->Get_Position(seen));
+	if (distance < minDist || distance > maxDist)
+		return;
+	int seenId = Commands->Get_ID(seen);
+	if (!enemyId)
+		AttackTarget(obj,seenId,seen);
+	else if (enemyId != seenId)
+	{
+		GameObject *enemy = Commands->Find_Object(enemyId);
+		if (!enemy || seenPriority > GetPriority(enemy))
+			AttackTarget(obj,seenId,seen);
+
+	}
+	if (enemyId == seenId)
+		resetTime = userSetResetTime;
+}
+void JMG_Utility_Base_Defense_Simple::Damaged(GameObject *obj,GameObject *damager,float damage)
+{
+	if (enemyId)
+		return;
+	Enemy_Seen(obj,damager);
+}
+void JMG_Utility_Base_Defense_Simple::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (enemyId)
+		{
+			GameObject *enemy = Commands->Find_Object(enemyId);
+			if (!enemy || !Commands->Get_Health(enemy))
+			{
+				enemyId = 0;
+				Commands->Action_Reset(obj,100);
+			}
+		}
+		if (resetTime)
+		{
+			resetTime--;
+			if (!resetTime)
+			{
+				enemyId = 0;
+				Commands->Action_Reset(obj,100);
+			}
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+float JMG_Utility_Base_Defense_Simple::GetPriority(GameObject *seen)
+{
+	if (seen->As_VehicleGameObj())
+		switch (Get_Vehicle_Mode(seen))
+		{
+			case VEHICLE_TYPE_CAR: return carTankBike.X;
+			case VEHICLE_TYPE_TANK: return carTankBike.Y;
+			case VEHICLE_TYPE_BIKE: return carTankBike.Z;
+			case VEHICLE_TYPE_FLYING: return flyingTurretBoat.X;
+			case VEHICLE_TYPE_TURRET: return flyingTurretBoat.Y;
+			case VEHICLE_TYPE_BOAT: return flyingTurretBoat.Z;
+			case VEHICLE_TYPE_SUB: return submarineInfantryUnused.X;
+		}
+	else if (seen->As_SoldierGameObj())
+		return submarineInfantryUnused.Y;
+	Console_Input("msg JMG_Utility_Base_Defense_Simple ERROR: Undefined vehicle type!");
+	return 0;
+}
+void JMG_Utility_Base_Defense_Simple::AttackTarget(GameObject *obj,int seenId,GameObject *seen)
+{
+	enemyId = seenId;
+	ActionParamsStruct params;
+	params.Set_Basic(this,100,2);
+	params.Set_Attack(seen,maxDistance,0.0,true);
+	Commands->Action_Attack(obj,params);
+	params.AttackCheckBlocked = false;
+}
+void JMG_Utility_Custom_Send_Custom_Supress_Spam::Created(GameObject *obj)
+{
+	char parameterName[128];
+	for (int x = 0;x < 10;x++)
+	{
+		sprintf(parameterName,"Custom%0d",x);
+		catchCustom[x] = Get_Int_Parameter(parameterName);
+	}
+	id = Get_Int_Parameter("ID");
+	lastCustom = 0;
+	lastParam = 0;
+	lastSentCustom = 0;
+	lastSentParam = 0;
+	senderId = 0;
+	spamDelay = Get_Float_Parameter("SpamDelay");
+	sendDuplicates = Get_Int_Parameter("SendDuplicates") != 0;
+	supressingSpam = false;
+}
+void JMG_Utility_Custom_Send_Custom_Supress_Spam::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		bool sent = false;
+		if (sendDuplicates || (lastCustom != lastSentCustom || lastParam != lastSentParam))
+			sent = SendCustom(obj);
+		if (!sent)
+			supressingSpam = false;
+		else
+			Commands->Start_Timer(obj,this,spamDelay,1);
+	}
+}
+void JMG_Utility_Custom_Send_Custom_Supress_Spam::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (catchCustom[0] == 0 || message == catchCustom[0] || message == catchCustom[1] || message == catchCustom[2] || message == catchCustom[3] || message == catchCustom[4] || message == catchCustom[5] || message == catchCustom[6] || message == catchCustom[7] || message == catchCustom[8] || message == catchCustom[9])
+	{
+		senderId = Commands->Get_ID(sender);
+		lastCustom = message;
+		lastParam = param;
+		if (!supressingSpam && (sendDuplicates || (message != lastSentCustom || param != lastSentParam)))
+		{
+			SendCustom(obj);
+			supressingSpam = true;
+			Commands->Start_Timer(obj,this,spamDelay,1);
+		}
+	}
+}
+bool JMG_Utility_Custom_Send_Custom_Supress_Spam::SendCustom(GameObject *obj)
+{
+	if (!lastCustom)
+		return false;
+	GameObject *sender = Commands->Find_Object(senderId);
+	if (!sender)
+		sender = obj;
+	GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 	Commands->Send_Custom_Event(sender,object,lastCustom,lastParam,0);
+	lastSentCustom = lastCustom;
+	lastSentParam = lastParam;
+	senderId = 0;
+	lastCustom = 0;
+	lastParam = 0;
+	return true;
+}
+void JMG_Utility_Send_Custom_When_Player_Between_Range::Created(GameObject *obj)
+{
+	sleeping = 0;
+	minDistance = Get_Float_Parameter("MinDistance");
+	minDistance *= minDistance;
+	maxDistance = Get_Float_Parameter("MaxDistance");
+	maxDistance *= maxDistance;
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("Custom");
+	param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	triggerOnce = Get_Int_Parameter("TriggerOnce") ? true : false;
+	sleepTime = Get_Int_Parameter("SleepTime");
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Send_Custom_When_Player_Between_Range::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1)
+	{
+		if (sleeping)
+			sleeping--;
+		else
+			for (int x = 1;x < 128;x++)
+			{
+				GameObject *player = Get_GameObj(x);
+				if (!player)
+					continue;
+				float playerDist = JmgUtility::SimpleDistance(Commands->Get_Position(player),Commands->Get_Position(obj));
+				if (playerDist <= maxDistance && playerDist >= minDistance)
+				{
+					GameObject *object = id ? Commands->Find_Object(id) : obj;
+					if (object)
+						Commands->Send_Custom_Event(obj,object,custom,param,delay);
+					if (triggerOnce)
+					{
+						this->Destroy_Script();
+						return;
+					}
+					sleeping = sleepTime;
+				}
+			}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Custom_Display_Briefing_PAMSG_Message_To_Player::Created(GameObject *obj)
+{
+	BriefingText = NULL;
+	lastNode = NULL;
+	int File = Commands->Text_File_Open(Get_Parameter("FileName"));
+	if (!File)
+	{
+		Console_Input("msg JMG_Utility_Custom_Display_Briefing_PAMSG_Message_To_Player ERROR: Text File not found!");
+		return;
+	}
+	bool NextLineIsTarget = false;
+	char TextString[16384];
+	while (Commands->Text_File_Get_String(File,TextString,16383))
+	{
+		if (!_stricmp(TextString,""))
+			continue;
+		if (!NextLineIsTarget)
+			for (int x = 0;x < 16384;x++)
+				if (TextString[x] == '\n' || TextString[x] == 13 || TextString[x] == '\0')
+					TextString[x] = '\0';
+		if (NextLineIsTarget)
+		{
+			int Count = 0;
+			for (int x = 0;x < 16384;x++)
+			{
+				if ((Count > 140 && TextString[x] == ' ') || Count == 200)
+				{// String getting too long, start a new one.
+					lastNode->Text[Count] = '\0';
+					AddNewTextNode();
+					Count = 0;
+				}
+				else if (TextString[x] == '\n' || TextString[x] == '\0')
+				{
+					lastNode->Text[Count] = '\0';
+					break;// end of line your done
+				}
+				else if (TextString[x] == '\f')
+				{
+					lastNode->Text[Count] = '\0';
+					AddNewTextNode();
+					Count = 0;
+				}
+				else
+				{
+					lastNode->Text[Count] = TextString[x];
+					Count++;
+				}
+			}
+			break;
+		}
+		else if (!_stricmp(TextString,Get_Parameter("TextTag")))
+		{
+			NextLineIsTarget = true;
+			AddNewTextNode();
+		}
+		TextString[0] = '\0';
+	}
+	Commands->Text_File_Close(File);
+}
+void JMG_Utility_Custom_Display_Briefing_PAMSG_Message_To_Player::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == Get_Int_Parameter("Custom"))
+	{
+		if (!Commands->Is_A_Star(sender))
+			return;
+		for (BriefingTextNode *node = lastNode;node;node = node->prev)
+		{
+			char tmpMsg[220];
+			sprintf(tmpMsg,"pamsg %d %s",JmgUtility::JMG_Get_Player_ID(sender),node->Text);
+			Console_Input(tmpMsg);
+		}
+	}
+}
+void JMG_Utility_Custom_Display_Briefing_PAMSG_Message_To_Player::Destroyed(GameObject *obj)
+{
+	RemoveTextNodes();
+}
+void JMG_Utility_Custom_Display_Briefing_PAMSG_Message_To_Player::AddNewTextNode()
+{
+	if (!BriefingText)
+	{
+		BriefingText = new BriefingTextNode;
+		sprintf(BriefingText->Text,"\0");
+		BriefingText->next = NULL;
+		lastNode = BriefingText;
+		return;
+	}
+	BriefingTextNode *Current = BriefingText;
+	while (Current)
+	{
+		if (!Current->next)
+		{
+			Current->next = new BriefingTextNode;
+			Current->next->prev = Current;
+			Current = Current->next;
+			sprintf(Current->Text,"\0");
+			Current->next = NULL;
+			lastNode = Current;
+			return;
+		}
+		Current = Current->next;
+	}
+}
+void JMG_Utility_Custom_Display_Briefing_PAMSG_Message_To_Player::RemoveTextNodes()
+{
+	BriefingTextNode *Current = BriefingText,*Temp;
+	while (Current)
+	{
+		Temp = Current;
+		Current = Current->next;
+		delete Temp;
+	}
+	BriefingText = NULL;
+	Destroy_Script();
+}
+void JMG_Utility_Send_Custom_On_Powerup_Pickup_Collector::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
+	{
+		int id = Get_Int_Parameter("ID");
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+		if (object)
+			Commands->Send_Custom_Event(sender,object,Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+	}
+}
+void JMG_Utility_Zone_Send_Custom_Enter_From_Enterer::Created(GameObject *obj)
+{
+	playerType = Get_Int_Parameter("PlayerType");
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("Custom");
+	param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	triggerOnce = Get_Int_Parameter("TriggerOnce") ? true : false;
+}
+void JMG_Utility_Zone_Send_Custom_Enter_From_Enterer::Entered(GameObject *obj,GameObject *enter)
+{
+	if (CheckPlayerType(enter,playerType) || Commands->Get_Player_Type(enter) == -4)
+		return;
+	GameObject *object = id ? (id == -1 ? enter : Commands->Find_Object(id)) : obj;
+	if (object)
+		Commands->Send_Custom_Event(enter,object,custom,param,delay);
+	if (triggerOnce)
+		Destroy_Script();
+}
+void JMG_Utility_AI_Lobbed_Vehicle_Projectile_Custom::Created(GameObject *obj)
+{
+	targetCustom = Get_Int_Parameter("TargetCustom");
+	minDistanceSquared = Get_Float_Parameter("MinDistance");
+	minDistanceSquared *= minDistanceSquared;
+	minAngle = Get_Float_Parameter("MinAngle");
+	maxAngle = Get_Float_Parameter("MaxAngle");
+	lowAngleMaxDistance = Get_Float_Parameter("UseLowAngleMaxDistance");
+	lowAngleMaxDistance *= lowAngleMaxDistance;
+	useLowAngleWhenAboveMinDistance = Get_Int_Parameter("UseLowAngleWhenAboveMinDistance") != 0;
+	useLowAngleTargetAboveHeight = Get_Float_Parameter("UseLowAngleTargetAboveHeight");
+	sprintf(vehicleProjectilePreset,"%s",Get_Parameter("VehicleProjectilePreset"));
+	fireVelocity = Get_Float_Parameter("FireVelocity");
+	gravityScale = Get_Float_Parameter("GravityScale");
+	missAmountPerMeter = Get_Float_Parameter("MissAmountPerMeter");
+	baseMissAmount = Get_Float_Parameter("BaseMissAmount");
+	fireDelay = Get_Float_Parameter("FireRate") == 0.0f ? 9999.9f : 1.0f/Get_Float_Parameter("FireRate");
+	reloadTime = Get_Float_Parameter("ReloadTime");
+	currentClipCount = clipCount = max(0,Get_Int_Parameter("ClipCount"));
+	velocitySquared = fireVelocity*fireVelocity;
+	sprintf(fireSound,"%s",Get_Parameter("FireSound"));
+	sprintf(projectileExplosion,"%s",Get_Parameter("ProjectileExplosion"));
+	sprintf(muzzleFlashExplosion,"%s",Get_Parameter("MuzzleFlashExplosion"));
+	sprintf(reloadSound,"%s",Get_Parameter("ReloadSound"));
+	aimTurret = Get_Int_Parameter("AimTurret") != 0;
+	refreshTime = Get_Int_Parameter("CustomTimeoutTime")*10;
+	projectedShotsChance = Get_Float_Parameter("ProjectedShotsChance");
+	if (Commands->Get_Random(0.0f,0.99999f) < projectedShotsChance)
+		projectShots = true;
+	delayComplete = true;
+	reloadComplete = true;
+	lastAngle = 9999.0f;
+	Commands->Disable_All_Collisions(obj);
+	Commands->Start_Timer(obj,this,0.01f,1);
+	Commands->Start_Timer(obj,this,0.1f,4);
+}
+void JMG_Utility_AI_Lobbed_Vehicle_Projectile_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (targetCustom == message)
+	{
+		if (!targetId)
+			targetId = param;
+		if (param == targetId)
+			timeoutTime = refreshTime;
+	}
+}
+void JMG_Utility_AI_Lobbed_Vehicle_Projectile_Custom::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		GameObject *seen = Commands->Find_Object(targetId);
+		if (!seen || !Commands->Get_Health(seen))
+			targetId = 0;
+		if (reloadComplete && delayComplete && targetId)
+		{
+			Vector3 myPos = Commands->Get_Bone_Position(obj,"FireSpot"),enemyPos = Commands->Get_Bone_Position(seen,"target");
+			if (seen->As_SmartGameObj() && projectShots)
+			{
+				double tmp = (fireVelocity*sin(lastAngle));
+				float flightTime = (float)((fireVelocity*sin(lastAngle)+sqrt(tmp*tmp+2*(gravityScale*9.8)*(myPos.Z-enemyPos.Z)))/(gravityScale*9.8));
+				Vector3 speed;
+				seen->As_SmartGameObj()->Get_Velocity(speed);
+				if (flightTime < 600.0f)
+				{
+					enemyPos.X += speed.X*flightTime;
+					enemyPos.Y += speed.Y*flightTime;
+					enemyPos.Z += speed.Z*flightTime;
+				}
+			}
+			float targetDist = JmgUtility::SimpleDistance(myPos,enemyPos),targetFlatDistance = JmgUtility::SimpleFlatDistance(myPos,enemyPos);
+			if (targetDist < minDistanceSquared)
+			{
+				Commands->Start_Timer(obj,this,0.01f,1);
+				return;
+			}
+			float targetMissAmount = 0.0f;
+			if (missAmountPerMeter)
+			{
+				float missAmount = Commands->Get_Distance(enemyPos,myPos)*missAmountPerMeter;
+				targetMissAmount = missAmount < baseMissAmount ? baseMissAmount : missAmount;
+			}
+			else if (baseMissAmount)
+				targetMissAmount = baseMissAmount;
+			if (targetMissAmount)
+			{
+				float rotation = Commands->Get_Random(-180.0f,180.0f);
+				enemyPos.X += cos(rotation)*Commands->Get_Random(0.0f,targetMissAmount);
+				enemyPos.Y += sin(rotation)*Commands->Get_Random(0.0f,targetMissAmount);
+			}
+			bool useHighAngle = true;
+			if (targetDist <= lowAngleMaxDistance)
+				useHighAngle = false;
+			else if (useLowAngleWhenAboveMinDistance && targetFlatDistance <= minDistanceSquared)
+				useHighAngle = false;
+			else if (useLowAngleTargetAboveHeight && Commands->Get_Position(obj).Z+useLowAngleTargetAboveHeight < Commands->Get_Position(seen).Z)
+				useHighAngle = false;
+			double height = enemyPos.Z-myPos.Z,angle;
+			if (!CalculateAngle(&angle,Commands->Get_Distance(enemyPos,myPos),height,useHighAngle))
+			{
+				Commands->Start_Timer(obj,this,0.01f,1);
+				return;
+			}
+			lastAngle = angle;
+			double zRotation = atan2(enemyPos.Y-myPos.Y,enemyPos.X-myPos.X);
+			FireProjectile(obj,zRotation,angle);
+			if (currentClipCount)
+				currentClipCount--;
+			if (!currentClipCount)
+			{
+				reloadComplete = false;
+				Commands->Start_Timer(obj,this,reloadTime,2);
+				Commands->Create_3D_Sound_At_Bone(reloadSound,obj,"Turret");
+			}
+			else
+			{
+				delayComplete = false;
+				Commands->Start_Timer(obj,this,fireDelay,3);
+			}
+			if (aimTurret)
+			{
+				float TempRotation = atan2(enemyPos.Y-myPos.Y,enemyPos.X-myPos.X);
+				Vector3 pos = Commands->Get_Bone_Position(obj,"barrel");
+				pos.X += (float)cos(TempRotation);
+				pos.Y += (float)sin(TempRotation);
+				pos.Z += (float)tan(angle);
+				ActionParamsStruct params;
+				params.Set_Attack(pos,0.0f,0,1);
+				params.AttackForceFire = false;
+				params.AttackCheckBlocked = false;
+				Commands->Action_Attack(obj,params);
+			}
+		}
+		Commands->Start_Timer(obj,this,0.01f,1);
+	}
+	if (number == 2)
+	{
+		if (Commands->Get_Random(0.0f,0.99999f) < projectedShotsChance)
+			projectShots = true;
+		else
+			projectShots = false;
+		currentClipCount = clipCount;
+		reloadComplete = true;
+	}
+	if (number == 3)
+	{
+		delayComplete = true;
+	}
+	if (number == 4)
+	{
+		if (timeoutTime)
+		{
+			timeoutTime--;
+			if (!timeoutTime)
+				targetId = 0;
+		}
+		Commands->Start_Timer(obj,this,0.1f,4);
+	}
+}
+bool JMG_Utility_AI_Lobbed_Vehicle_Projectile_Custom::CalculateAngle(double *returnAngle,double distance,double height,bool highAngle)
+{
+	double calculatedGravity = gravityScale*9.8;
+	if (distance <= 0.0)
+		return false;
+	double x = velocitySquared*velocitySquared-calculatedGravity*(calculatedGravity*(distance*distance)+2*height*velocitySquared);
+	if (x < 0)
+		return false;
+	*returnAngle = atan((velocitySquared+(highAngle ? 1 : -1)*sqrt(x))/(calculatedGravity*distance));
+	if (*returnAngle*180.0/PI < minAngle || *returnAngle*180.0/PI > maxAngle)
+		return false;
+	return true;
+}
+void JMG_Utility_AI_Lobbed_Vehicle_Projectile_Custom::FireProjectile(GameObject *obj,double zAngle,double aimAngle)
+{
+	Commands->Create_3D_Sound_At_Bone(fireSound,obj,"MuzzleA0");
+	GameObject *projectile = Commands->Create_Object(vehicleProjectilePreset,Commands->Get_Bone_Position(obj,"FireSpot"));
+	Commands->Create_Explosion(muzzleFlashExplosion,Commands->Get_Bone_Position(obj,"muzzleA0"),obj);
+	char params[220];
+	sprintf(params,"%d,%s",Commands->Get_ID(obj),projectileExplosion);
+	Commands->Attach_Script(projectile,"JMG_AI_Artillery_Targeting_Fire_Vehicle_Projectile_Attach",params);
+	Vector3 normalizedVector = Vector3((float)cos(zAngle),(float)sin(zAngle),(float)tan(aimAngle));
+	normalizedVector.Normalize();
+	normalizedVector.X *= fireVelocity;
+	normalizedVector.Y *= fireVelocity;
+	normalizedVector.Z *= fireVelocity;
+	Set_Velocity(projectile,normalizedVector);
+}
+void JMG_Utility_Vehicle_Enter_Send_Custom_From_Enterer::Created(GameObject *obj)
+{
+	team = Get_Int_Parameter("PlayerType");
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("Custom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	triggerOnce = Get_Int_Parameter("TriggerOnce") != 0;
+}
+void JMG_Utility_Vehicle_Enter_Send_Custom_From_Enterer::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
+	{
+		if (CheckPlayerType(sender,team))
+			return;
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+		Commands->Send_Custom_Event(sender,object,custom,Param,delay);
+		if (triggerOnce)
+			Destroy_Script();
+	}
+}
+void JMG_Utility_Custom_Send_Custom_On_Count_From_Sender::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+	resetCustom = Get_Int_Parameter("ResetCustom");
+	count = Get_Int_Parameter("Count");
+}
+void JMG_Utility_Custom_Send_Custom_On_Count_From_Sender::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == resetCustom)
+	{
+		count = Get_Int_Parameter("Count");
+	}
+	if (message == custom && count)
+	{
+		count--;
+		if (count)
+			return;
+		int id = Get_Int_Parameter("ID");
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+		if (object)
+		{
+			int Param = Get_Int_Parameter("Param");
+			Commands->Send_Custom_Event(sender,object,Get_Int_Parameter("SendCustom"),Param == -1 ? param : Param,Get_Float_Parameter("Delay"));
+		}
+	}
+}
 ScriptRegistrant<JMG_Utility_Check_If_Script_Is_In_Library> JMG_Utility_Check_If_Script_Is_In_Library_Registrant("JMG_Utility_Check_If_Script_Is_In_Library","ScriptName:string,CppName:string");
 ScriptRegistrant<JMG_Send_Custom_When_Custom_Sequence_Matched> JMG_Send_Custom_When_Custom_Sequence_Matched_Registrant("JMG_Send_Custom_When_Custom_Sequence_Matched","Success_Custom=0:int,Correct_Step_Custom=0:int,Partial_Failure_Custom=0:int,Failure_Custom=0:int,Send_To_ID=0:int,Custom_0=0:int,Custom_1=0:int,Custom_2=0:int,Custom_3=0:int,Custom_4=0:int,Custom_5=0:int,Custom_6=0:int,Custom_7=0:int,Custom_8=0:int,Custom_9=0:int,Disable_On_Success=1:int,Disable_On_Failure=0:int,Starts_Enabled=1:int,Enable_Custom=0:int,Correct_Step_Saftey=0:int,Failure_Saftey=1:int,Max_Failures=1:int");
 ScriptRegistrant<JMG_Utility_Change_Model_On_Timer> JMG_Utility_Change_Model_On_Timer_Registrant("JMG_Utility_Change_Model_On_Timer","Model=null:string,Time=0:float");
